package it.egesuato.model;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.TypedQuery;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Join;
import javax.persistence.criteria.JoinType;
import javax.persistence.criteria.Root;

public class Main {
	public static void main(String[] args){
	    EntityManagerFactory factory = Persistence.createEntityManagerFactory("myjpa");
	    EntityManager em = factory.createEntityManager();

	    em.getTransaction().begin();
	    
	    Person p = new Person();
	    p.setName("person");
	    em.persist(p);
	    
	    CriteriaBuilder cb = em.getCriteriaBuilder();
	    CriteriaQuery<Object[]> cq = cb.createQuery(Object[].class);
	    Root<Person> root = cq.from(Person.class);
	    Join<Person, Address> join = root.join("address", JoinType.LEFT);
	    
	    cq.multiselect(
	    		root.get("name"),
	    		join
	    		);
	    
	    
	    TypedQuery<Object[]> q = em.createQuery(cq);
	    
	    List resultList = q.getResultList();

	    em.getTransaction().commit();

	    em.close();		
	}
}
